package com.ruoyi.project.business.mapper;

import java.util.List;
import com.ruoyi.project.business.domain.TcFollow;
import com.ruoyi.project.business.domain.TcFollowForList;
import com.ruoyi.project.business.domain.vo.reminder.AreaSalesDirectorVO;
import com.ruoyi.project.business.domain.vo.reminder.CheckAreaSalesDirectorVO;
import com.ruoyi.project.system.domain.SysUser;

/**
 * 【跟进管理】Mapper接口
 * 
 * @author ruoyi
 * @date 2024-04-07
 */
public interface TcFollowMapper 
{
    /**
     * 查询【跟进管理】
     * 
     * @param followId 【跟进管理】主键
     * @return 【跟进管理】
     */
    public TcFollow selectTcFollowByFollowId(Long followId);

    /**
     * 查询【请填写功能名称】列表
     * 
     * @param tcFollow 【跟进管理】
     * @return 【跟进管理】集合
     */
    public List<TcFollowForList> selectTcFollowList(TcFollow tcFollow);

    /**
     * 新增【跟进管理】
     * 
     * @param tcFollow 【跟进管理】
     * @return 结果
     */
    public int insertTcFollow(TcFollow tcFollow);

    /**
     * 修改【跟进管理】
     * 
     * @param tcFollow 【跟进管理】
     * @return 结果
     */
    public int updateTcFollow(TcFollow tcFollow);

    /**
     * 删除【跟进管理】
     * 
     * @param followId 【跟进管理】主键
     * @return 结果
     */
    public int deleteTcFollowByFollowId(Long followId);

    /**
     * 批量删除【跟进管理】
     * 
     * @param followIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTcFollowByFollowIds(Long[] followIds);

    /**
     * 获取新的跟进编号
     *
     * @return 结果
     */
    public String getNewFollowNo();

    List<TcFollow> selectTcFollowListByTypeAndBusinessId(TcFollow tcFollow);

    /**
     * 查询客户相关跟进管理列表
     *
     * @param tcFollow 跟进管理
     * @return 结果
     */
    List<TcFollowForList> selectTcFollowListByAccount(TcFollow tcFollow);

    /**
     * 查询查询代理商的userId
     *
     * @param agentId  代理商ID
     * @return 结果
     */
    List<SysUser>  selectUserInfoByAgentId(Long agentId);

    /**
     * 查询所有销售区域总监的信息
     *
     * @return 结果
     */
    List<AreaSalesDirectorVO> selectAreaSalesDirector();

    /**
     * 校验是否是该代理商的销售区域总监
     *
     * @return 结果
     */
    Long getCountByAgentPermissionChar(CheckAreaSalesDirectorVO checkVO);

    int selectCountByAccountId(Long accountId);

    List<Long> selectCountryIdsByCurUser(String permissionCharIns);
}
